import os
from pathlib import Path

from django.apps import AppConfig
from django.conf import settings


class CabConfig(AppConfig):
    name = 'main'

    def ready(self):

        # remove all tasks
        for i in Path(settings.PATH_DIR_TASKS).iterdir():
            if 'spoolfile' in i.name:
                os.remove(i)
