$(document).ready(function () {
    // for bootstrap 3 use 'shown.bs.tab', for bootstrap 2 use 'shown' in the next line
    $('[data-toggle="tab"]').on('shown.bs.tab', function (e) {
        // save the latest tab; use cookies if you like 'em better:
        localStorage.setItem('lastTab', $(this).attr('href'));
        if (this.classList.contains('rule_key_tab')) {
            localStorage.setItem('rule_tab', $(this.querySelector('.tab_rule_settings.active')).attr('href'));
        } else if (this.classList.contains('tab_rule_settings')) {
            localStorage.setItem('rule_tab', $(this).attr('href'));
            localStorage.setItem('lastTab', '#' + $(this.closest('.rule_key_tab')).attr('id'));
        } else {
            localStorage.removeItem('rule_tab');
        }

    });

    let lastTab = localStorage.getItem('lastTab');
    if (lastTab) {
        let select_tab = $('[href="' + lastTab + '"]');
        select_tab.trigger('click');
        if (select_tab[0] !== undefined && select_tab[0] !== null && select_tab[0].classList.contains('rule_key_tab')) {
            let rule_tab = localStorage.getItem('rule_tab');
            if (rule_tab) {
                let select_rule_tab = $('[href="' + rule_tab + '"]');
                select_rule_tab.tab('show');

            }
        }
    }
});