let home = document.getElementById('home').title;

$(document).ready(function () {
    var elem = document.getElementsByClassName('left-sidebar-link clearfix active')[0];
    var footer = $('#Footer');
    var date_div = document.getElementById('dateDiv');
    var search_div = document.getElementById('searchDiv');
    var search_div_scan = document.getElementById('searchDivScanner');
    var domain_div = document.getElementById('domainDiv');
    var hamburger = $('button.navbar-toggle');
    if (elem == null) {
        return;
    }
    if (elem.classList.contains('tab_attack_charts')) {
        footer.hide();
        if ($(window).width() < 992)
            hamburger.show();
        if (typeof (domain_div) != 'undefined' && domain_div != null) {
            domain_div.removeAttribute("style");
        }
        search_div.removeAttribute("style");
        date_div.removeAttribute("style");

        $('#attack_table_search_input').attr("placeholder", "(!)h:example.com and (!)ip:1.1.1.1 and (!)t:SQLi");

        search_div_scan.setAttribute("style", "display:none");
    }
    if (elem.classList.contains('tab_user_settings')) {
        footer.hide();
        if ($(window).width() < 992)
            hamburger.show();
        if (typeof (domain_div) != 'undefined' && domain_div != null) {
            domain_div.removeAttribute("style");
        }
        search_div.removeAttribute("style");
        date_div.removeAttribute("style");

        $('#attack_table_search_input').attr("placeholder", "(!)h:example.com and (!)ip:1.1.1.1 and (!)t:SQLi");

        search_div_scan.setAttribute("style", "display:none");
        $('.custom-navbar-left').hide();

    }
    if (elem.classList.contains('tab_attack_scanner')) {
        footer.show();
        hamburger.hide();
        date_div.setAttribute("style", "display:block");

        if (typeof (domain_div) != 'undefined' && domain_div != null) {
            domain_div.setAttribute("style", "display:none");
        }
        search_div.setAttribute("style", "display:none");
        search_div_scan.setAttribute("style", "display:block");

    }
    if (elem.classList.contains('tab_attack_traffic')) {
        footer.show();
        hamburger.hide();
        date_div.setAttribute("style", "display:none");

        if (typeof (domain_div) != 'undefined' && domain_div != null) {
            domain_div.setAttribute("style", "display:none");
        }
        search_div.setAttribute("style", "display:none");
        search_div_scan.setAttribute("style", "display:none");
    }

    if (elem.classList.contains('tab_attack_table')) {
        footer.hide();
        if ($(window).width() < 992)
            hamburger.show();
        if (typeof (domain_div) != 'undefined' && domain_div != null) {
            domain_div.removeAttribute("style");
        }
        search_div.removeAttribute("style");
        date_div.removeAttribute("style");

        $('#attack_table_search_input').attr("placeholder", "(!)h:example.com and (!)ip:1.1.1.1 and (!)t:SQLi");

        search_div_scan.setAttribute("style", "display:none");
    }


});

$(document).ready(function () {
    var today = new Date();
    var prevDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 5);
    var startDate = ('0' + prevDate.getDate()).slice(-2)
        + '.'
        + ('0' + (prevDate.getMonth() + 1)).slice(-2)
        + '.'
        + prevDate.getFullYear();

    var endDate = ('0' + today.getDate()).slice(-2)
        + '.'
        + ('0' + (today.getMonth() + 1)).slice(-2)
        + '.'
        + today.getFullYear();

    var $_GET = getQueryParams(document.location.search);
    startDate = $_GET['start'] || startDate;
    endDate = $_GET['end'] || endDate;
    if (document.getElementById('csv_start_date_input') != null) {
        document.getElementById('csv_start_date_input').value = startDate;
        document.getElementById('csv_end_date_input').value = endDate;
    }

    if (document.getElementById('start_date_input') != null) {
        document.getElementById('start_date_input').value = startDate;
        document.getElementById('end_date_input').value = endDate;
    }

    $('[data-toggle="tooltip"]').tooltip({
        trigger: 'hover'
    });
    $('.pdf_report-button').on('click', function ($event) {
        $event.preventDefault();
        $('.pdf_report-form').submit();

    });
    $('.csv_report-button').on('click', function ($event) {
        //$event.preventDefault();
        $('.csv_report-form').submit();
    })
});

//Unused newLogRequest ???

function newlogRequest() {
    var domain_n = window.domain;
    var start_date_n = window.start_date;
    var end_date_n = window.end_date;

    var elementCollection = [];
    var allElements = document.getElementsByClassName("pk_id");

    for (var i = 0; i < allElements.length; i++) {
        elementCollection.push(allElements[i].value);
    }
    var max_id_n = Math.max.apply(Math, elementCollection);
    if (max_id_n != '-Infinity') {
        url = home + 'newlogs/?domain=' + domain_n + '&start=' + start_date_n + '&end=' + end_date_n + '&id=' + max_id_n;
        if (url.indexOf('recheck') > -1) {
            return;
        }
        if (window.search != '') {
            url += '&search=' + window.search
        }
        $.get(url, function (data) {

            $('#table_logs tbody:first').before(data);
        });
    }
}

//$(document).ready(setInterval(newlogRequest,30000));

$(document).on('click', '.desc-info', function (e) {
    let row_id = e.target.parentNode.parentElement.getElementsByClassName('pk_id')[0].value;
    $('#long_desc').hide();

    $.get(home + "get_long_desc/", {row_id: row_id})
        .success(function (data, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(data);
                return;
            }
            if (data.long_description !== null && data.long_description.length !== 0) {
                $('#long_desc').text(data.long_description);
            } else {
                $('#long_desc').text(gettext('Description is missing'));
            }
            $('#long_desc').show();
            $('#longDescModal').modal('show');
            $('body').css('padding-right', 0);
        });
});

$(document).on('click', '.large-body-info', function (e) {
    let row_id = e.target.parentNode.getElementsByClassName('pk_id')[0].value;

    $('#large_body').hide();
    $('#largeBodyModal .loading-container').show()
    $('#largeBodyModal').modal('show');

    $.get(home + "get_large_body/", {row_id: row_id})
        .success(function (data, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(data);
                return;
            }
            if (data.body !== null && data.body.length !== 0) {
                $('#large_body').text(data.body);
            } else {
                $('#large_body').text(gettext('Content is missing'));
            }
            $('#largeBodyModal .loading-container').hide();
            $('#large_body').show();
            $('body').css('padding-right', 0);
        });
});

$(document).on('click', '.rule-info', function (e) {
    var rule_id = e.target.innerHTML;
    rule_id = rule_id.split(" ")[0];
    var row_id = e.target.parentNode.getElementsByClassName('row-id')[0].innerHTML;
    $.get(home + "get_rule/", {rule_id: rule_id, row_id: row_id})
        .success(function (data, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(data);
                return;
            }
            if (typeof data.id !== 'undefined') {
                if (data.flags == 0) {
                    var flag = gettext('No');
                } else if (data.flags == 2) {
                    var flag = gettext('Yes');
                }

                var zone = JSON.stringify(data.zone.join(","));
                $('#mdialog').css('max-width', '600px');
                $('#mfoot-btn').show();
                $('#rulesTable').show();
                $('#wlTable').show();
                $('#nf').hide();
                $('#ef').hide();
                $('#uds').hide();
                $('#rl-id').text(data.id);
                $('#rl-type').text(data.score_k);
                $('#rl-zone').text(zone.replace(/\,/g, ' | ').replace(/\"/g, ''));
                $('#rl-sc').text(data.score_v);
                $('#rl-targer').text(data.target);
                $('#rl-px').text(flag);
                if (data.plan == -1) {
                    $('#wl-info').empty();
                    $('#wl-info').text(data.wl);
                } else {
                    $('#wl-info').empty();
                    let btn = document.createElement("button");
                    btn.textContent = gettext('Create an exclusion rule');
                    btn.className = 'btn btn-default wl-rule _rule';
                    btn.style.marginBottom = '5px';
                    btn.style.borderRadius = '10px';
                    let hidden_id = document.createElement('input');
                    hidden_id.value = data.wl_data.row_id;
                    hidden_id.type = 'hidden';
                    hidden_id.name = 'row_id';
                    $('#wl-info').append(btn);
                    $('#wl-info').append(hidden_id);
                }
            } else if (data.status === 'empty') {
                setTimeout(function () {
                    $("#rulesModal").modal('hide');
                }, 2000);
                $('#mdialog').css('max-width', '400px');
                $('#ef').css('padding-top', '20px');
                $('#mfoot-btn').hide();
                $('#ef').show();
                $('#nf').hide();
                $('#uds').hide();
                $('#wlTable').hide();
                $('#rulesTable').hide();
            } else if (Number(rule_id) >= 50000) {
                setTimeout(function () {
                    $("#rulesModal").modal('hide');
                }, 2000);
                $('#mdialog').css('max-width', '300px');
                $('#uds').css('padding-top', '20px');
                $('#mfoot-btn').hide();
                $('#uds').show();
                $('#nf').hide();
                $('#ef').hide();
                $('#wlTable').hide();
                $('#rulesTable').hide();
            } else {
                setTimeout(function () {
                    $("#rulesModal").modal('hide');
                }, 2000);
                $('#mdialog').css('max-width', '300px');
                $('#nf').css('padding-top', '20px');
                $('#mfoot-btn').hide();
                $('#nf').show();
                $('#ef').hide();
                $('#uds').hide();
                $('#wlTable').hide();
                $('#rulesTable').hide();
            }

            $('#rulesModal').modal('show');
            $('body').css('padding-right', 0);
        });
});

$(document).ready(function () {
    let zone_select_title = $('#zone_select_title').text();
    let zone_selected_title = $('#zone_selected_title').text();
    let zone_all_selected_title = $('#zone_all_selected_title').text();
    $('.zone_select').multiselect({
        nonSelectedText: zone_select_title,
        nSelectedText: zone_selected_title,
        allSelectedText: zone_all_selected_title,
        numberDisplayed: 1,
        buttonClass: 'btn multi-select-button',
        optionClass: function (element) {
            return 'multi-select-option'
        },
    });
    $('[data-toggle="tooltip"]').tooltip({
        placement: 'bottom',
    })

});

wl_rule_change = false;
$(document).on('click', '.wl-rule', function (e) {
    $('.wl_group').remove();
    $('#error_add_wl').css({'display': 'none'});
    let wl_rule_modal = $('#wl_rule');
    wl_rule_modal.find('#add_wl_id').val('');
    wl_rule_modal.find('#add_wl_domain').val('');
    $('option', $('.zone_select')).each(function (element) {
        $(this).removeAttr('selected').prop('selected', false);
    });
    let row_id = null;
    if (e.target.classList.contains('_rule')) {
        row_id = e.target.parentNode.querySelector('input[name="row_id"]').value;

    } else {
        row_id = $(e.target.parentNode).parent().parent().parent()[0].id.split('_')[2];
    }
    $.get(home + "get_rule_wl/", {row_id: row_id})
        .success(function (data, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(data);
                return;
            }
            wl_rule_modal.modal('show');
            wl_rule_modal.find('#add_wl_id').val(data.wl_id);
            wl_rule_modal.find('#add_wl_domain').val(data.domain);
            wl_rule_modal.find('#add_wl_key').val(data.key_id);
            let mz = [data.mz];
            $('.zone_select').multiselect('select', mz);
            $("#add_wl_form").change(function () {
                wl_rule_change = true;
            });
        });
});

function add_extension(id) {
    wl_rule_change = true;
    let wl_extension_title = $('.wl_extension_title').text();
    let wl_extension_regex_title = $('.wl_extension_regex_title').text();
    let wl_extension_select_zone_title = $('.wl_extension_select_zone_title').text();
    let wl_extension_custom_zone_input = $('.wl_extension_custom_zone_input').text();
    let wl_extension_input = $('.wl_extension_input').text();
    let add_group_class = '';
    if (id === 'add') {
        add_group_class = ' wl_group';
    }

    let last_ext_count = Number($('.extension_count_' + id + ':last').val()) + 1;
    $('.extension_count_' + id + ':last').val(last_ext_count);


    $('#last_extension_field_' + id).before('<div class="extension_' + id + add_group_class + '">\n' +
        '                        <div class="form-group" style="text-align: center">\n' +
        '                            <div class="col-sm-12">\n' +
        '                                <label for="select_extension_' + id + '_' + last_ext_count + '"\n' +
        '                                       style="font-weight: 200;">' + wl_extension_title + '</label>\n' +
        '                                <br>\n' +
        '                            </div>\n' +
        '                        </div>\n' +
        '                        <div class="form-group" style="text-align: center">\n' +
        '                            <div class="col-sm-4">\n' +
        '                                <select id="select_extension_' + id + '_' + last_ext_count + '" class="form-control"\n' +
        '                                        onchange="show_input_custom_zone(this,\'' + id + '\',\'' + last_ext_count + '\')"' +
        ' style="background: #FFFFFF; color: #555; border: 1.5px solid #D5E4F3; font-size: 14px; border-radius: 4px;height: 43px;font-style: normal;" >\n' +
        '                                    <option value="none">' + wl_extension_select_zone_title + '\n' +
        '                                    </option>\n' +
        '                                    <option value="body">BODY\n' +
        '                                    </option>\n' +
        '                                    <option value="url">URL\n' +
        '                                    </option>\n' +
        '                                    <option value="args">ARGS\n' +
        '                                    </option>\n' +
        '                                    <option value="headers">\n' +
        '                                        HEADERS\n' +
        '                                    </option>\n' +
        '                                </select>\n' +
        '                            </div>\n' +
        '                            <div class="col-sm-5">\n' +
        '                                <input type="text" title="' + wl_extension_input + '"\n' +
        '                                       class="form-control extension_text wl-input" value=""\n' +
        '                                       placeholder="' + wl_extension_input + '"\n' +
        '                                       style="background-color: #ffffff; font-size: 16px; border-radius: 0px; border-width: 0px; border-bottom-width: 1px; text-align: center; box-shadow: none;">\n' +
        '                            </div>\n' +
        '                            <div class="col-sm-3">\n' +
        '                                <input class="form-check-input regex_extension no-checkbox-radio" type="checkbox" value="true"\n' +
        '                                       id="regex_rl_' + id + '_' + last_ext_count + '">\n' +
        '                                <label class="form-check-label" for="regex_rl_' + id + '_' + last_ext_count + '" ' +
        'style="font-weight: normal;font-size: 16px;">\n' +
        '                                    ' + wl_extension_regex_title + '\n' +
        '                                </label>\n' +
        '                            </div>\n' +
        '                        </div>\n' +
        '                    </div>');
}

function add_wl(status = '') {
    if ((wl_rule_change === false) && (status !== 'confirm')) {
        $('#confirm_wl').modal('show');
        event.preventDefault();
    } else {
        let home = document.getElementById('home').title;
        if (add_wl.cantClick) {
            event.preventDefault();
            return;
        }
        add_wl.cantClick = true;
        let add_domain = $('#add_wl_domain');
        let add_wl_id = $('#add_wl_id');
        let add_zone = $('#zone');
        let validate = true;

        $('#error_add_wl').css({'display': 'none'});


        $('.zone_validation').css({'display': 'none'});

        if ((add_zone.val() === null) && ($('#add_other_zone').val() === '')) {
            event.preventDefault();
            $('.zone_validation').css({'display': 'block'});
            validate = false;

        }
        if (add_wl_id.val() === '') {
            event.preventDefault();
            $('.wl_id_validation').css({'display': 'block'});
            add_wl_id.css({'border-color': 'red'});
            validate = false;

        }
        if (validate) {
            let key_id = $('#add_wl_key').val();
            let div_extension = $('.extension_add');
            let extension_array = [];
            $.each(div_extension, function () {

                let extension_select = $(this).find('select').val();
                if (extension_select === 'custom_zone') {
                    extension_select = $(this).find('.extension_custom_zone').val().trim();
                }
                let extension_text = $(this).find('.extension_text').val().trim();
                let extension_regex = $(this).find('.regex_extension').is(':checked');

                extension_array.push(extension_select + ';' + extension_text + ';' + extension_regex);

            });
            const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
            event.preventDefault();
            $.ajax({
                url: home + 'add_wl/',
                headers: {'X-CSRFToken': csrftoken},
                type: "POST",
                dataType: "html",
                data: {
                    form: $('#add_wl_form').serialize(),
                    extension: extension_array,
                },
                success: function (response, textStatus, xhr) {
                    if (xhr.status == 255) {
                        show_messages_from_response(response);
                        return;
                    }
                    if (response !== '{"status": "error"}') {
                        let zone_select_title = $('#zone_select_title').text();
                        let zone_selected_title = $('#zone_selected_title').text();
                        let zone_all_selected_title = $('#zone_all_selected_title').text();
                        $('.zone_select').multiselect({
                            nonSelectedText: zone_select_title,
                            nSelectedText: zone_selected_title,
                            allSelectedText: zone_all_selected_title,
                            numberDisplayed: 1,
                        });
                        $('#wl_rule').modal('hide');
                        $('#add_wl_form').trigger('reset');
                        $('.zone_select').multiselect('refresh');
                        $('.wl_group').remove();
                        wl_rule_change = false;
                    } else {
                        $('#error_add_wl').css({'display': 'block'});
                    }

                },
                error: function (response) {
                    show_messages_from_response(response.responseText)
                }
            });
        }
        setTimeout(() => {
            add_wl.cantClick = false;
        }, 1000);
    }

}

function exclude_row(obj) {
    var row_id = "row_" + obj.id;
    $.ajax({
        url: home + "exclude-request/",
        method: 'get',
        dataType: 'html',
        data: {report_id: obj.id},
        success: function (data, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(data);
                return;
            }
            $('[id=' + row_id + ']').hide()
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

$('#attack_table_search_input').bind({
    focusin: function () {
        if ($('#tab_attack_charts').is(":visible")) {
            var history = 'searh_history_list';
            var divID = '#searh_history';
        } else if ($('#tab_attack_table').is(":visible")) {
            var history = 'attack_searh_history_list';
            var divID = '#attack_searh_history';
        }
        var count = document.getElementById(history).getElementsByTagName('li').length;
        if (count === 0) {
            $(divID).css('display', 'none');
        } else if (count === 1) {
            $(divID).css('display', 'flex');
        } else {
            $(divID).css('display', 'flex');
        }
    },
    keyup: function (e) {
        if ($('#tab_attack_charts').is(":visible")) {
            var divID = '#searh_history';
        } else if ($('#tab_attack_table').is(":visible")) {
            var divID = '#attack_searh_history';
        }
        if (e.keyCode === 13) {
            $('#attack_table_search_input').trigger("input");
            $(divID).css('display', 'none');
        }
    }

});

$('#search-input').bind({
    focusin: function () {
        var count = document.getElementById('scan_searh_history_list').getElementsByTagName('li').length;
        if (count === 0) {
            $('#scanner_attack_searh_history').css('display', 'none');
        } else if (count === 1) {
            $('#scanner_attack_searh_history').css('display', 'flex');
        } else {
            $('#scanner_attack_searh_history').css('display', 'flex');

        }
    },
    keyup: function (e) {
        if (e.keyCode === 13) {
            $('#scanner_attack_searh_history').css('display', 'none');
        }
    }

});

$(document).ready(function (e) {
    $("#searh_history_list").on("click", ".searh_history_element", function (event) {
        $('#attack_table_search_input').val(event.target.textContent);
        let e = jQuery.Event("keyup");
        e.key = 'Enter';
        $('#attack_table_search_input').trigger(e);
        $('#searh_history').css('display', 'none');
        $('#input-group').css('margin-top', '0px');
        window.lastevent = 'click';


    });
});

$(document).ready(function (e) {
    $("#attack_searh_history_list").on("click", ".searh_history_element", function (event) {
        $('#attack_table_search_input').val(event.target.textContent);
        let e = jQuery.Event("keyup");
        e.key = 'Enter';
        $('#attack_table_search_input').trigger(e);
        $('#attack_searh_history').css('display', 'none');
        $('#input-group').css('margin-top', '0px');
        window.lastevent = 'click';

    });
});

$(document).ready(function (e) {
    $("#scanner_attack_searh_history").on("click", ".searh_history_element", function (event) {
        $('#search-input').val(event.target.textContent);
        let e = jQuery.Event('keyup');
        e.key = 'Enter';
        $('#search-input').trigger(e);
        $('#scanner_attack_searh_history').css('display', 'none');
        $('#scanner_input-group').css('margin-top', '0px');
        window.lastevent = 'click';
    });
});

$(document).mouseup(function (e) {
    if ($('#tab_attack_charts').is(":hidden")) {
        if ($('#tab_attack_table').is(":visible")) {
            var container = $("#attack_searh_history");
        } else if ($('#scanner').is(":visible")) {
            var container = $("#scanner_attack_searh_history");
        }
    } else {
        var container = $("#searh_history");
    }

    if (container !== undefined) {
        if ((container.has(e.target).length === 0) && (e.target.id !== 'attack_table_search_input') && (e.target.id !== 'search-input')) {
            $(container).css('display', 'none');
            $('#input-group').css('margin-top', '0px');
            $('#scanner_attack_searh_history').css('display', 'none');
            $('#scanner_input-group').css('margin-top', '0px');

        }
    }
});

$(window).resize(function () {
    if ($(window).width() <= 1030) {
        $('.attack-table-info-text').width($(window).width() / 3.2);
    } else if ($(window).width() >= 1031 && ($(window).width() <= 1160)) {
        $('.attack-table-info-text').width($(window).width() / 3);
    } else if ($(window).width() >= 1160 && ($(window).width() <= 1314)) {
        $('.attack-table-info-text').width($(window).width() / 2.9);
    } else if ($(window).width() >= 1314 && ($(window).width() <= 1469)) {
        $('.attack-table-info-text').width($(window).width() / 2.7);
    } else if ($(window).width() >= 1470 && ($(window).width() <= 1680)) {
        $('.attack-table-info-text').width($(window).width() / 4.6);
    } else if ($(window).width() >= 1681 && ($(window).width() <= 1820)) {
        $('.attack-table-info-text').width($(window).width() / 4.4);
    } else if ($(window).width() >= 1821) {
        $('.attack-table-info-text').width($(window).width() / 4.2);
    }
});


function select_file_for_drag_box(e) {
    let box_drop = e.closest('.box_drop_full').querySelector('.box_drop');
    let file_name = e.value.split('\\').pop();
    if (!file_name.includes('.json') && !file_name.includes('.yml') && !file_name.includes('.yaml')) {
        file_name = gettext('Upload the file in JSON or YAML formats');
        box_drop.querySelector('.box_drop_text span').classList.add('text-danger');
        box_drop.closest('form').querySelector('.save_button').classList.add('disabled');
    } else {
        box_drop.querySelector('.box_drop_text span').classList.remove('text-danger');
        box_drop.closest('form').querySelector('.save_button').classList.remove('disabled');
        if (file_name.length > 20) {
            file_name = file_name.substring(0, 17) + '...';
        }
    }

    box_drop.querySelector('.box_drop_text span').innerText = file_name;

}


function load_open_api_schema(id, edit = false) {
    $('.error_load_open_api_schema').hide();
    let home = document.getElementById('home').title;
    var formData = new FormData();
    if (!edit) {
        if ($("#open_api_schema_name_" + id).val().length === 0) {
            $("#open_api_schema_name_" + id).parent().addClass('has-error');
            return false;
        } else {
            $("#open_api_schema_name_" + id).parent().removeClass('has-error');
        }
        let f = $("#load_openapi_schema_" + id).prop('files')[0];
        if (f === undefined || (!f.name.includes('.json') && !f.name.includes('.yml') && !f.name.includes('.yaml'))) {
            return false;
        }
        formData.append('api_schema', f);
        formData.append('key', $("#addKeyID_" + id).val());
        formData.append('schema_name', $("#open_api_schema_name_" + id).val());

    } else {
        if ($("#edit_schema_name_" + id).val().length === 0) {
            $("#edit_schema_name_" + id).parent().addClass('has-error');
            return false;
        } else {
            $("#edit_schema_name_" + id).parent().removeClass('has-error');
        }
        
        formData.append('key', $("#editKeyID" + id).val());
        formData.append('schema_name', $("#edit_schema_name_" + id).val());
        formData.append('edit', 1);

        formData.append('old_name', $("#old_name_schema_" + id).val());

    }
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    $.ajax({
        type: "POST",
        url: home + 'load_openapi_schema/',
        headers: {'X-CSRFToken': csrftoken},
        cache: false,
        contentType: false,
        processData: false,
        data: formData,
        success: function (dat, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(dat);
                return;
            }
            if (dat.status === 'error') {
                $('.error_load_open_api_schema').show();
            } else {

                location.reload();

                $('.error_load_open_api_schema').hide();

            }
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

$(document).ready(function (e) {
    $(".openapi_domain").click(function (e) {
        $(e.currentTarget).next().toggle("slow", function () {
        });
    });

    $('.row-schema').click(function (e) {
        if (!e.target.classList.contains('path_name') && e.target.closest('.merge_btn') !== null
            && e.target.closest('.merge_btn') !== undefined) {
            return;
        }

        let box_paths = e.currentTarget.parentElement.querySelector('.block_path');
        if (!box_paths.classList.contains('open')) {
            $(box_paths).show("slow", function () {
                let tmp = e.currentTarget.querySelector('.tog_car');
                tmp.classList.remove('fa-caret-right');
                tmp.classList.add('fa-caret-down');
                box_paths.classList.add('open');
            });
        } else {
            $(box_paths).hide("slow", function () {
                let tmp = e.currentTarget.querySelector('.tog_car');
                tmp.classList.add('fa-caret-right');
                tmp.classList.remove('fa-caret-down');
                box_paths.classList.remove('open');
            });
        }
    });

    $(document).on('click', '.yes_del_schema', function (e) {
        e.currentTarget.classList.remove('yes_del_schema');
        $.ajax({
            type: "POST",
            url: home + 'delete_openapi_schema/',
            headers: {'X-CSRFToken': csrftoken},
            data: window.del_data_schema,
            success: function (dat, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(dat);
                    return;
                }
                if (dat.status === 'error') {

                } else {
                    location.reload();
                }
            },
            error: function (response) {
                show_messages_from_response(response.responseText)
            }
        });
    });

    $(document).on('click', '.yes_del_rows', function (e) {
        if (window.del_rows.length <= 0 || window.del_data_rows.length <= 0) {
            return
        }
        e.currentTarget.classList.remove('yes_del_rows');
        $.ajax({
            type: "POST",
            url: home + 'delete_from_openapi_schema/',
            headers: {'X-CSRFToken': csrftoken},
            dataType: "json",
            data: {data: JSON.stringify(window.del_data_rows)},
            success: function (dat, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(dat);
                    return;
                }
                if (dat.status === 'error') {

                } else {
                    let j = window.del_rows[0].closest('.block_path ').parentElement;
                    for (let i of window.del_rows) {
                        i.remove();
                    }
                    if (j.childElementCount <= 0) {
                        location.reload();
                    }
                    reloadTagsMethod();
                }
            },
            error: function (response) {
                show_messages_from_response(response.responseText)
            }
        });
    });

    $(document).on('click', '.yes_del_paths', function (e) {
        e.currentTarget.classList.remove('yes_del_paths');
        $.ajax({
            type: "POST",
            url: home + 'delete_openapi_path/',
            headers: {'X-CSRFToken': csrftoken},
            dataType: "json",
            data: window.del_excl_rows_data,
            success: function (dat, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(dat);
                    return;
                }
                if (dat.status === 'error') {

                } else {
                    let j = window.del_excl_rows[0].closest('.block_path ');
                    for (let i of window.del_excl_rows) {
                        i.remove();
                    }
                    if (j.childElementCount <= 1) {
                        let tmp = document.querySelector("[href='#" + j.closest('.block-schema').id + "']").parentElement;
                        if (tmp.nextElementSibling != null && tmp.nextElementSibling != undefined) {
                            $(tmp.nextElementSibling.querySelector('a')).trigger('click');
                        }
                        tmp.remove();
                        j.closest('.block-schema').remove();
                    }
                }
            },
            error: function (response) {
                show_messages_from_response(response.responseText)
            }
        });
    });

    $(document).on('click', '.yes_excl_paths', function (e) {
        e.currentTarget.classList.remove('yes_excl_paths');
        $.ajax({
            type: "POST",
            url: home + 'exclude_openapi_path/',
            headers: {'X-CSRFToken': csrftoken},
            dataType: "json",
            data: window.del_excl_rows_data,
            success: function (dat, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(dat);
                    return;
                }
                if (dat.status === 'error') {

                } else {
                    let j = window.del_excl_rows[0].closest('.block_path ');
                    for (let i of window.del_excl_rows) {
                        i.remove();
                    }
                    if (j.childElementCount <= 1) {
                        let tmp = document.querySelector("[href='#" + j.closest('.block-schema').id + "']").parentElement;
                        if (tmp.nextElementSibling != null && tmp.nextElementSibling != undefined) {
                            $(tmp.nextElementSibling.querySelector('a')).trigger('click');
                        }
                        tmp.remove();
                        j.closest('.block-schema').remove();
                    }
                }
            },
            error: function (response) {
                show_messages_from_response(response.responseText)
            }
        });
    });

    $(document).on('click', '.yes_merge_paths', function (e) {
        e.currentTarget.classList.remove('yes_merge_paths');
        $.ajax({
            type: "POST",
            url: home + 'merge_schema/',
            headers: {'X-CSRFToken': csrftoken},
            dataType: "json",
            data: window.merge_rows,
            success: function (dat, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(dat);
                    return;
                }
                if (dat.status === 'error') {

                } else {
                    location.reload();
                }
            },
            error: function (response) {
                show_messages_from_response(response.responseText)
            }
        });
    });

    $(document).on('click', '.yes_del_excl_paths', function (e) {
        e.currentTarget.classList.remove('yes_del_excl_paths');
        $.ajax({
            type: "POST",
            url: home + 'remove_exclude_openapi_paths/',
            headers: {'X-CSRFToken': csrftoken},
            dataType: "json",
            data: window.del_data_excl_paths,
            success: function (dat, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(dat);
                    return;
                }
                if (dat.status === 'error') {

                } else {
                    let j = window.del_excl_paths_rows[0].closest('.block_path ');
                    for (let i of window.del_excl_paths_rows) {
                        i.remove();
                    }
                    if (j.childElementCount <= 1) {
                        let tmp = document.querySelector("[href='#" + j.closest('.block-schema').id + "']").parentElement;
                        if (tmp.nextElementSibling != null && tmp.nextElementSibling != undefined) {
                            $(tmp.nextElementSibling.querySelector('a')).trigger('click');
                        }
                        tmp.remove();
                        j.closest('.block-schema').remove();
                    }
                }
            },
            error: function (response) {
                show_messages_from_response(response.responseText)
            }
        });
    });


    $('.del_row').click(function (e) {
        let key_id = e.currentTarget.closest('.box-schema').querySelector('.tk_id').value;
        let sch_name = e.currentTarget.closest('.box-schema').querySelector('.sch-name').value;
        let confirm = document.querySelector('#confirmModal');
        let b = confirm.querySelector('.confirm_btn');
        b.classList.add('yes_del_rows');
        confirm.querySelector('#bodyConfirm').innerText = gettext('Delete row?');
        let url = [];
        url.push(e.currentTarget.closest('.block_path').querySelector('.cb_rows').value);
        window.del_rows = [];
        window.del_rows.push(e.currentTarget.closest('.block_path'));
        window.del_data_rows = {'key': key_id, 'schema_name': sch_name, 'url': url};
    });

    $('.del_cur_path').click(function (e) {
        let key_id = e.currentTarget.closest('.block-schema').querySelector('.tk_id').value;
        let excl_path = e.currentTarget.closest('.row_excl_path').querySelector('.cb-excl-paths').value;
        let schm_name = e.currentTarget.closest('.block-schema').querySelector('.sch-name').value;
        let confirm = document.querySelector('#confirmModal');
        let b = confirm.querySelector('.confirm_btn');
        b.classList.add('yes_del_excl_paths');
        confirm.querySelector('#bodyConfirm').innerText = gettext('Delete path?');
        window.del_excl_paths_rows = [];

        window.del_excl_paths_rows.push(e.currentTarget.closest('.row_excl_path'));
        window.del_data_excl_paths = {
            'key': key_id,
            'schema_name': schm_name,
            'paths': JSON.stringify([{"schema_name": schm_name, 'url': excl_path}])
        };
    });

    $('.delete_selected_paths').click(function (e) {
        let key_id = e.currentTarget.closest('.block-schema').querySelector('.tk_id').value;
        let schm_name = e.currentTarget.closest('.block-schema').querySelector('.sch-name').value;
        let confirm = document.querySelector('#confirmModal');
        let b = confirm.querySelector('.confirm_btn');
        let excl_paths = [];
        window.del_excl_paths_rows = [];
        for (let i of e.currentTarget.closest('.block-schema').querySelectorAll('.cb-excl-paths:checked')) {
            excl_paths.push({"schema_name": schm_name, "url": i.value});
            window.del_excl_paths_rows.push(i.closest('.row_excl_path'));
        }
        b.classList.add('yes_del_excl_paths');
        confirm.querySelector('#bodyConfirm').innerText = gettext('Delete paths?');
        window.del_data_excl_paths = {'key': key_id, 'schema_name': schm_name, 'paths': JSON.stringify(excl_paths)};
    });

    $('.delete_rows_schema').click(function (e) {
        let key_id = e.currentTarget.closest('.box-schema').querySelector('.tk_id').value;
        let sch_name = e.currentTarget.closest('.box-schema').querySelector('.sch-name').value;
        let confirm = document.querySelector('#confirmModal');
        let b = confirm.querySelector('.confirm_btn');
        b.classList.add('yes_del_rows');
        confirm.querySelector('#bodyConfirm').innerText = gettext('Delete rows?');
        let url = [];
        window.del_rows = [];
        for (let i of e.currentTarget.closest('.box-schema').querySelectorAll('.cb_rows:checked')) {
            url.push(i.value);
            window.del_rows.push(i.closest('.block_path'));
        }
        window.del_data_rows = {'key': key_id, 'schema_name': sch_name, 'url': url};
    });

    $('.delete_schema').click(function (e) {
        let key_id = e.currentTarget.closest('.box-schema').querySelector('.tk_id').value;
        let sch_name = e.currentTarget.closest('.box-schema').querySelector('.sch-name').value;
        let confirm = document.querySelector('#confirmModal');
        let b = confirm.querySelector('.confirm_btn');
        b.classList.add('yes_del_schema');
        confirm.querySelector('#bodyConfirm').innerText = gettext('Delete schema?');
        window.del_data_schema = {'key': key_id, 'schema_name': sch_name};
    });

    $('.del_excl_row').click(function (e) {
        let key_id = e.currentTarget.closest('.block-schema').querySelector('.tk_id').value;
        let sch_name = e.currentTarget.closest('.block-schema').querySelector('.sch-name').value;
        let confirm = document.querySelector('#confirmDelExclModal');
        let eb = confirm.querySelector('.exclude_btn');
        let db = confirm.querySelector('.delete_btn');
        eb.classList.add('yes_excl_paths');
        db.classList.add('yes_del_paths');
        let url = '';
        window.del_excl_rows_data = url;
        url = e.currentTarget.closest('.openapi_path_name').querySelector('.cb-paths').value;
        window.del_excl_rows = [e.currentTarget.closest('.openapi_path_name')];
        window.del_excl_rows.push(e.currentTarget.closest('.openapi_path_name').nextElementSibling);
        confirm.querySelector('#bodyConfirmDelExcl').innerText = gettext('Delete or exclude?');
        window.del_excl_rows_data = {'key': key_id, 'schema_name': sch_name, 'url': url};
    });

    $('.merge_btn').click(function (e) {
        let key_id = e.currentTarget.closest('.block-schema').querySelector('.tk_id').value;
        let sch_name = e.currentTarget.closest('.block-schema').querySelector('.sch-name').value;
        let confirm = document.querySelector('#confirmModal');
        let eb = confirm.querySelector('.confirm_btn');
        eb.classList.add('yes_merge_paths');
        let url = [];
        window.merge_rows = [];
        for (let i of e.currentTarget.closest('.block-schema').querySelectorAll('.cb-paths:checked')) {
            url.push(i.value);
        }
        if (url.length == 0) {
            for (let i of e.currentTarget.closest('.block-schema').querySelectorAll('.cb-paths')) {
                url.push(i.value);
            }
        }
        if (e.currentTarget.querySelector('img') != null) {
            confirm.querySelector('#bodyConfirm').innerText = pgettext('openapi', 'Merge paths?');
        } else {
            confirm.querySelector('#bodyConfirm').innerText = pgettext('openapi', 'Create schema?');
        }
        window.merge_rows = {'key': key_id, 'schema_name': sch_name, 'paths': url};
    });

    $('.cb-all-paths').click(function (e) {
        let boxes = e.currentTarget.closest('.block_path').querySelectorAll('.cb-paths');
        if ($(e.currentTarget).is(':checked')) {
            $(boxes).prop('checked', true);
        } else {
            $(boxes).prop('checked', false);
        }

        let selected_cb = e.currentTarget.closest('.block_path').querySelectorAll('.cb-paths:checked').length;
        let merge_btn = e.currentTarget.closest('.block_path').parentElement.querySelector('.merge_btn');
        if (selected_cb == 0 && merge_btn != null) {
            if (merge_btn.querySelector('img') != null) {
                let f = '<img src="' + window.share_icon_href + '" style="height: 25px; width: 25px; color: white; filter: brightness(0) invert(1);">';
                merge_btn.innerHTML = f;
                merge_btn.title = pgettext('openapi', 'Merge all');
            } else {
                let i_icon = document.createElement('i');
                i_icon.className = 'fa fa-plus';
                i_icon.style.padding = '6px 7px';
                i_icon.title = pgettext('openapi', 'Create schema');
                merge_btn.innerHTML = '';
                merge_btn.appendChild(i_icon);
            }
        } else {
            if (merge_btn.querySelector('img') != null) {
                let f = '<img src="' + window.share_all_icon_href + '" style="height: 25px; width: 25px; color: white; filter: brightness(0) invert(1);">';
                merge_btn.innerHTML = f;
                merge_btn.title = pgettext('openapi', 'Merge selected');
            } else {
                let i_icon = document.createElement('i');
                i_icon.className = 'fa fa-plus';
                i_icon.style.padding = '6px 7px';
                i_icon.title = pgettext('openapi', 'Create schema with selected');
                merge_btn.innerHTML = '';
                merge_btn.appendChild(i_icon);
            }
        }
    });

    $('.cb-paths').click(function (e) {
        let all_coutn_cb = e.currentTarget.closest('.block_path').querySelectorAll('.cb-paths').length;
        let selected_cb = e.currentTarget.closest('.block_path').querySelectorAll('.cb-paths:checked').length;
        let cb_all = e.currentTarget.closest('.block_path').querySelector('.cb-all-paths');
        if (all_coutn_cb > selected_cb) {
            $(cb_all).prop('checked', false);
        } else {
            $(cb_all).prop('checked', true);

        }
        let merge_btn = e.currentTarget.closest('.block_path').parentElement.querySelector('.merge_btn');
        if (selected_cb == 0 && merge_btn != null) {
            if (merge_btn.querySelector('img') != null) {
                let f = '<img src="' + window.share_icon_href + '" style="height: 25px; width: 25px; color: white; filter: brightness(0) invert(1);">';
                merge_btn.innerHTML = f;
                merge_btn.title = pgettext('openapi', 'Merge all');
            } else {
                let i_icon = document.createElement('i');
                i_icon.className = 'fa fa-plus';
                i_icon.style.padding = '6px 7px';
                i_icon.title = pgettext('openapi', 'Create schema');
                merge_btn.innerHTML = '';
                merge_btn.appendChild(i_icon);
            }
        } else {
            if (merge_btn.querySelector('img') != null) {
                let f = '<img src="' + window.share_all_icon_href + '" style="height: 25px; width: 25px; color: white; filter: brightness(0) invert(1);">';
                merge_btn.innerHTML = f;
                merge_btn.title = pgettext('openapi', 'Merge selected');
            } else {
                let i_icon = document.createElement('i');
                i_icon.className = 'fa fa-plus';
                i_icon.style.padding = '6px 7px';
                i_icon.title = pgettext('openapi', 'Create schema with selected');
                merge_btn.innerHTML = '';
                merge_btn.appendChild(i_icon);
            }
        }

    });

    $('.cb-all-excl-paths').click(function (e) {
        let boxes = e.currentTarget.closest('.block-schema').querySelectorAll('.cb-excl-paths');
        if ($(e.currentTarget).is(':checked')) {
            $(boxes).prop('checked', true);
        } else {
            $(boxes).prop('checked', false);
        }

    });

    $('.cb-excl-paths').click(function (e) {
        let all_coutn_cb = e.currentTarget.closest('.block-schema').querySelectorAll('.cb-excl-paths').length;
        let selected_cb = e.currentTarget.closest('.block-schema').querySelectorAll('.cb-excl-paths:checked').length;
        let cb_all = e.currentTarget.closest('.block-schema').querySelector('.cb-all-excl-paths');
        if (all_coutn_cb > selected_cb) {
            $(cb_all).prop('checked', false);
        } else {
            $(cb_all).prop('checked', true);

        }

    });

    $('.cb_rows ').click(function (e) {
        let all_coutn_cb = e.currentTarget.closest('.box-schema').querySelectorAll('.cb_rows').length;
        let selected_cb = e.currentTarget.closest('.box-schema').querySelectorAll('.cb_rows:checked').length;
        let cb_all = e.currentTarget.closest('.box-schema').querySelector('.cb_all_rows');

        if (all_coutn_cb > selected_cb) {
            $(cb_all).prop('checked', false);
        } else {
            $(cb_all).prop('checked', true);

        }
    });

    $('.cb_all_rows ').click(function (e) {
        let boxes = e.currentTarget.closest('.box-schema').querySelectorAll('.cb_rows');

        if ($(e.currentTarget).is(':checked')) {
            $(boxes).prop('checked', true);
        } else {
            $(boxes).prop('checked', false);
        }

    });

    $('.edit_schema').click(function (e) {
        let key_id = e.currentTarget.closest('.box-schema').querySelector('.tk_id').value;
        document.querySelector('#edit_schema_name_' + key_id).value = e.currentTarget.closest('.box-schema').querySelector('.sch-name').value;
        document.querySelector('#old_name_schema_' + key_id).value = e.currentTarget.closest('.box-schema').querySelector('.sch-name').value;
    });

    $(".openapi_path_name").click(function (e) {
        if (!e.target.classList.contains('openapi_path_name') && !e.target.classList.contains('path_name')) {
            return;
        }
        let block_path = e.currentTarget.closest('.block_path');
        let block_path_methods = '';
        if (block_path.querySelectorAll('.openapi_path_methods').length > 1) {
            block_path_methods = e.currentTarget.closest('.openapi_path_name').nextElementSibling;
        } else {
            block_path_methods = block_path.querySelector('.openapi_path_methods');
        }
        block_path_methods.classList.toggle('open');
        if (block_path_methods.classList.contains('open')) {
            $(block_path_methods.children).show("slow", function () {
            });
        } else {
            $(block_path_methods.children).hide("slow", function () {
            });

        }
    });

    $(document).on('click', '.sort-method', function (e) {
        let list_methods = ['get', 'post', 'put', 'delete', 'head', 'connect', 'trace', 'options', 'patch'];
        let lines = e.currentTarget.closest('.box-schema').querySelectorAll('.block_path');
        let methods = [];
        e.currentTarget.classList.toggle('selected');
        for (let i of list_methods) {
            let mt = e.currentTarget.closest('.box-methods').querySelector('.' + i);
            if (mt !== null) {
                if (mt.classList.contains('selected')) {
                    methods.push(i);
                }
            }
        }
        for (let i of lines) {
            let show = false
            for (let m of methods) {
                if (i.querySelector('.' + m) !== null) {
                    show = true;
                }
            }
            if (show || methods.length === 0) {
                $(i).show();
            } else {
                $(i).hide();
            }
        }
    });

    $(".openapi_path_method").click(function (e) {
        let method = e.currentTarget.innerText;
        let block_path = e.currentTarget.closest('.block_path');
        let block_path_data = block_path.querySelector('.openapi_path_data.' + method.toLowerCase());
        let box_methods = [];
        if (block_path.querySelectorAll('.openapi_path_methods').length > 1) {
            box_methods = e.currentTarget.closest('.openapi_path_name').nextElementSibling;
        } else {
            box_methods = block_path.querySelector('.openapi_path_methods');
        }
        for (let i of box_methods.children) {
            if (!i.classList.contains(method.toLowerCase())) {
                $(i).hide();
            }
        }
        $(block_path_data).toggle("slow", function () {
        });
    });

    $('.block_path').ready(function () {
        reloadTagsMethod();
    });
});


function reloadTagsMethod() {
    if (document.querySelector('.block_path') !== null) {
        let boxes_schemas = document.querySelectorAll('.box-schema');
        let list_methods = ['get', 'post', 'put', 'delete', 'head', 'connect', 'trace', 'options', 'patch'];
        for (let box_schema of boxes_schemas) {
            let box_methods = box_schema.querySelector('.box-methods');
            $(box_methods).empty();
            for (let method of list_methods) {
                if (box_schema.querySelector(`.${method}`) !== null) {
                    let b = document.createElement('button');
                    b.classList.add('method-openapi');
                    b.classList.add(method);
                    b.classList.add('sort-method');
                    b.innerText = method.toUpperCase();
                    box_methods.appendChild(b);

                }
            }
        }
    }
}
