function check_circle(c, t) {
    var cc = document.getElementById("check");
    if (cc == null) {
        return
    }
    var cn = cc.classList;
    var tn = cn[cn.length - 1];
    cn.remove(tn);
    cn.add(c);
    cc.title = t;
}

function check_c() {
    let url = window.location.href;
    if (url.includes('admin_panel')) {
        url = window.location.href.slice(0, url.indexOf('admin_panel'));
    } else {
        url = ''
    }
    $.ajax({
        url: url + 'model_tuning/check_rules/',
        type: 'GET',
        success: function (data) {
            if (data['status'] == 'danger') {
                check_circle('text-danger', 'rules file not-found')
            } else if (data['status'] == 'warning') {
                check_circle('text-warning', 'rules file empty')
            } else if (data['status'] == 'error') {
                check_circle('text-warning', 'rules update service error')
            } else if (data['status'] == 'old') {
                check_circle('text-warning', 'rules file old')
            } else {
                check_circle('text-success', 'rules file ok')
            }
        }
    });
}

check_c();
//setInterval(check_c, 30000);