function sortTable(n) {
    var table, rows, switching, i, x, y, container, shouldSwitch, dir, switchcount = 0;
    table = document.getElementById("myTable");
    switching = true;
    // Set the sorting direction to ascending:
    dir = "asc";
    /* Make a loop that will continue until
    no switching has been done: */
    if (n == 'bt') {
        container = 'contain_bt';
        n = 1;
    } else if (n == 'vhost') {
        container = 'contain_vhost';
        n = 2;
    } else if (n == 'ip') {
        container = 'contain_ip';
        n = 2
    } else if (n == 'timestamp') {
        container = 'contain_timestamp';
        n = 2
    } else if (n == 'uri') {
        container = 'contain_uri';
        n = 4
    } else if (n == 'args') {
        container = 'contain_args';
        n = 4
    } else if (n == 'cookie') {
        container = 'contain_cookie';
        n = 4
    } else if (n == 'ua') {
        container = 'contain_ua';
        n = 4
    } else if (n == 'body') {
        container = 'contain_body';
        n = 4
    } else if (n == 'referer') {
        container = 'contain_referer';
        n = 4
    } else if (n == 'other_headers') {
        container = 'contain_other_headers';
        n = 4
    }
    while (switching) {
        // Start by saying: no switching is done:
        switching = false;
        rows = table.rows;
        /* Loop through all table rows (except the
        first, which contains table headers): */
        for (i = 1; i < (rows.length - 1); i++) {
            // Start by saying there should be no switching:
            shouldSwitch = false;
            /* Get the two elements you want to compare,
            one from current row and one from the next: */
            x = rows[i].getElementsByTagName("TD")[n];
            y = rows[i + 1].getElementsByTagName("TD")[n];
            /* Check if the two rows should switch place,
            based on the direction, asc or desc: */
            if (n == 4) {
                if (x.getElementsByClassName(container).length > 0) {
                    first = x.getElementsByClassName(container)[0].innerHTML.toLowerCase();
                } else {
                    first = '';
                }
                if (y.getElementsByClassName(container).length > 0) {
                    second = y.getElementsByClassName(container)[0].innerHTML.toLowerCase();
                } else {
                    second = '';
                }
            } else {
                first = x.getElementsByClassName(container)[0].firstElementChild.innerHTML.toLowerCase();
                second = y.getElementsByClassName(container)[0].firstElementChild.innerHTML.toLowerCase()
            }
            if (dir == "asc") {
                if (first.replace(/\s/g, '') > second.replace(/\s/g, '')) {
                    // If so, mark as a switch and break the loop:
                    shouldSwitch = true;
                    break;
                }
            } else if (dir == "desc") {
                if (first.replace(/\s/g, '') < second.replace(/\s/g, '')) {
                    // If so, mark as a switch and break the loop:
                    shouldSwitch = true;
                    break;
                }
            }
        }
        if (shouldSwitch) {
            /* If a switch has been marked, make the switch
            and mark that a switch has been done: */
            rows[i].parentNode.insertBefore(rows[i + 1], rows[i]);
            switching = true;
            // Each time a switch is done, increase this count by 1:
            switchcount++;
        } else {
            /* If no switching has been done AND the direction is "asc",
            set the direction to "desc" and run the while loop again. */
            if (switchcount == 0 && dir == "asc") {
                dir = "desc";
                switching = true;
            }
        }
    }
}