from django import template

register = template.Library()


@register.filter
def attack_short_count(count):
    if count > 1000000:
        return str(round(count / 1000000, 1)) + "M"
    elif count > 1000:
        return str(round(count / 1000, 1)) + "K"
    else:
        return str(count)
