from django import template
from main.common import get_user_key_waf_id, get_user_key_waf_id_enter
from django.conf import settings

register = template.Library()


@register.filter
def ws_is_available(user):
    return True if len(get_user_key_waf_id(user)) > 0 and settings.API_URI else False


@register.filter
def oa_is_available(user):
    return True if len(get_user_key_waf_id(user, without_lite=True)) > 0 and settings.API_URI else False


@register.filter
def ec_is_available(user):
    return True if len(get_user_key_waf_id_enter(user)) > 1 and settings.API_URI else False


@register.filter
def mt_is_available(user):
    return True if len(get_user_key_waf_id(user, without_lite=True)) > 0 and settings.API_URI else False


@register.filter
def sc_is_available(user):
    return True if len(get_user_key_waf_id_enter(user)) > 1 and settings.API_URI else False
