import base64

from django import template

register = template.Library()


@register.filter
def encode_erl(value):
    if isinstance(value, list):
        for el in value:
            el[1] = base64.b64encode(str(el[1]).encode('utf-8')).decode('utf-8')
        res = []
        for parameters in value:
            res += ''.join(parameters)
        value = ''.join(res)
    return value
