import base64

from django import template

register = template.Library()


@register.filter
def encode_other_headers(value):
    if value == '':
        return ''
    else:
        for el in value:
            if '!!' in el['key']:
                el['key'] = base64.b64encode(str(el['key'])[2:].encode('utf-8')).decode('utf-8')
                el['key'] = '!!' + el['key']
            else:
                el['key'] = base64.b64encode(str(el['key']).encode('utf-8')).decode('utf-8')
            for v in el['value']:
                v[1] = base64.b64encode(str(v[1]).encode('utf-8')).decode('utf-8')
            res = []
            for parameters in el['value']:
                res += ''.join(parameters)
            el['value'] = ''.join(res)

        result = []
        for el in value:
            try:
                if el['value'][0] == ' ':
                    result.append(el['key'] + ':' + el['value'][1:])
                else:
                    result.append(el['key'] + ':' + el['value'])
            except IndexError:
                result.append(el['key'] + ':' + el['value'])

        return ','.join(result)
