from django import template

register = template.Library()


@register.filter
def get_country(value):
    if len(value.split(" ")) > 1:
        if value.split(" ")[1] == "(Multicast":
            return "(Multicast IP)"
        else:
            ip = str(value.split(" ")[1])
            country = ip[ip.find("(") + 1:ip.find("(") + 3]
            return country.lower()
    else:
        return ""
