from django import template
import json

register = template.Library()


@register.filter
def split_json(input_json):
    prjson = input_json.split('\n')[1:-1]
    return prjson


@register.filter
def pretty_json(dictionary):
    return json.dumps(dictionary, ensure_ascii=False, indent=2)
