from django import template

register = template.Library()


@register.filter
def reducing(value: str):
    len_val = len(value)
    if len_val > 15:
        return value[:6] + '***' + value[-6:]
    else:
        return value
