from django.urls import re_path
from . import views

urlpatterns = [
    re_path(r'^$', views.index_mt, name='index MT'),
    re_path(r'^search/$', views.search_in_table, name='index'),
    re_path(r'^delete/$', views.delete_rows, name='delete_rows'),
    re_path(r'^export/$', views.export_rows, name='export_rows'),
    re_path(r'^check/$', views.check_rows, name='check_rows'),
    # re_path(r'^custom_check/$', views.custom_check, name='custom_check'),
    re_path(r'^edit/$', views.edit_fp, name='edit_fp'),
    re_path(r'^edit_export/$', views.edit_export, name='edit_export'),
    re_path(r'^(?P<row_id>\d+)$', views.detail_row, name='detail'),
    re_path(r'^check_rules/$', views.check_rules, name='check_rules'),
    re_path(r'^ip_info/$', views.ip_info, name='get ip info'),
    re_path(r'^remove_all_by_ip/$', views.remove_all_by_ip, name='remove all by ip'),
]
