from django.conf import settings
from main.models import Geo_Tokens


def check_geo_ip_tokens(main, filed="alias") -> list:
    """Check geotoken and update alias for get logs group"""
    tokens_geo = {}
    for token in Geo_Tokens.objects.using('waf').all():
        tokens_geo[token.waf_id] = token.geo_token
    for i in main:
        if isinstance(i, dict):
            i['geotoken'] = tokens_geo.get(str(i[filed]))
        else:
            i.geotoken = tokens_geo.get(str(getattr(i, filed)))
    return main
