from django.db import models


class MachineLearning(models.Model):
    waf_id = models.TextField(verbose_name='WAF ID', primary_key=True)
    ml_learning_progress = models.TextField()
    vhost = models.TextField()

    class Meta:
        managed = False
        db_table = 'ml'


class Training(models.Model):
    waf_id = models.TextField(blank=True, null=False, primary_key=True)
    vhost = models.TextField(blank=True, null=True)
    duration = models.IntegerField(blank=True, null=True)
    complete = models.BooleanField(blank=True, null=True)
    progress = models.IntegerField(blank=True, null=True)

    class Meta:
        managed = False
        db_table = 'training'
