function searchItem(field, value) {
    value = (typeof value === 'undefined') ? event.target.parentNode.innerText.trim() : value;
    if (field === 'timestamp') {
        return;
    }
    if (value.endsWith(':')) {
        field = 'mz';
        value = value.slice(0, -1);
    }
    if (value === 'Refs.') {
        value = 'Ref';
    }
    let newValue = field + ':' + value;

    let urlParams = new URLSearchParams(window.location.search);
    let oldValue = urlParams.get('q');

    if (oldValue) {
        urlParams.set('q', oldValue + ' and ' + newValue)
    } else {
        urlParams.set('q', newValue)
    }

    window.location.search = urlParams.toString();
}

function search_for_args(args) {



    $.ajax({
        url: window.home + 'model_tuning/?' + args + '&s=1',
        type: 'GET',
        timeout: 0,
        success: function (data) {
            window.scrollTo(top);
            let context = document.querySelector('.context');
            let link_next = document.querySelector('.infinite-more-link');
            if (link_next == null) {
                link_next = document.createElement('a');
                link_next.className = 'infinite-more-link';
                document.querySelector('.base_container').appendChild(link_next);
                window.infinite.$more = $('.infinite-more-link');
            }
            link_next.setAttribute('href', `?page=2&${args}`);

            $(context).html(data);
            window.Waypoint.refreshAll()
            if (window.infinite.waypoint !== undefined){
            if (window.infinite.waypoint !== null && window.infinite.waypoint.group !== null
                && window.infinite.waypoint.group.waypoints.length === 0) {
                window.infinite.waypoint = new Waypoint(window.infinite.options);
            }}

            window.Waypoint.refreshAll()

            $('[data-toggle="tooltip"]').tooltip({
                trigger: 'hover',
            });



        },
        error: function (response) {
            try {
                let data = JSON.parse(response.responseText);
                let block_messages = document.getElementById('messages-block');



                if (data['messages'] != null && data['messages'] !== undefined) {
                    for (let message of data['messages']) {
                        let container = document.createElement('div');
                        container.className = 'container-fluid p-0';
                        let alert_div = '<div class="alert ' + message.tags + ' alert-dismissible" role="alert" style="margin-bottom: 10px">\n' +
                            '                <button type="button" class="close" data-dismiss="alert" aria-label="Close">\n' +
                            '                  <span aria-hidden="True">&times;</span>\n' +
                            '                </button>\n' +
                            '                ' + message.message + '\n' +
                            '              </div>'
                        $(container).html(alert_div);
                        block_messages.appendChild(container);

                    }
                }

            } catch (e) {

            }

        }
    });
}

$(document).on('click', '.st-table-filter-clear', function (e) {
    document.querySelector('#myInput').value = '';
    let ev = jQuery.Event("keyup");
    ev.key = 'Enter';
    let urlParams = new URLSearchParams(window.location.search);
    urlParams.set('q', '');
    history.pushState('', document.title, window.location.pathname + '?' + urlParams);
    $('#myInput').trigger(ev);
    location.reload()
});

$(document).on('click', '#showPassword  ', function () {
    let val = document.querySelector('#myInput').value;
    let ev = jQuery.Event("keyup");
    ev.key = 'Enter';
    let urlParams = new URLSearchParams(window.location.search);
    urlParams.set('q', val);
    history.pushState(val, document.title, window.location.pathname + '?' + urlParams);
    $('#myInput').trigger(ev);
    location.reload()
});



$(document).on('keyup', '#myInput', function (e) {
    let val = document.querySelector('#myInput').value;
    let urlParams = new URLSearchParams(window.location.search);
    urlParams.set('q', val);
});
