function searchItem(field, value) {
    value = (typeof value === 'undefined') ? event.target.parentNode.innerText.trim() : value;
    value = value.toLowerCase();
    field = field.toLowerCase();
    if (field === 'timestamp') {
        return;
    }
    if (value.endsWith(':')) {
        field = 'mz';
        value = value.slice(0, -1);
    }
    if (value == 'refs.') {
        value = 'ref';
    }
    var newValue = '';
    if (!value.startsWith(field + ':')) {
        newValue = field + ':' + value.trim();
    } else {
        newValue = value.split(':', 2);
        newValue = newValue[0].trim() + ':' + newValue[1].trim();
    }
    var urlParams = new URLSearchParams(window.location.search);
    var oldValue = urlParams.get('q');

    if (oldValue) {
        urlParams.set('q', oldValue + ' and ' + newValue)
    } else {
        urlParams.set('q', newValue)
    }
    search_for_args(urlParams.toString());
    if (oldValue != null) {
        document.querySelector('#input_search_false_pos').value = oldValue + ' and ' + newValue;
    } else {
        document.querySelector('#input_search_false_pos').value = newValue;

    }
}

function search_for_args(ars) {
    let url = window.location.href;
    if (url.includes('admin_panel')) {
        url = window.location.href.slice(0, url.indexOf('admin_panel'));
    } else {
        url = ''
    }
    $.ajax({
        url: url + 'model_tuning/search/?' + ars,
        type: 'GET',
        success: function (data) {
            let context = document.querySelector('.context');
            $(context).html(data);
        }
    });
}

$(document).on('keyup', '#input_search_false_pos', function (e) {
    if (e.key !== 'Enter') {
        return;
    }
    let val = document.querySelector('#input_search_false_pos').value;
    let urlParams = new URLSearchParams(window.location.search);
    urlParams.set('q', val);
    search_for_args(urlParams.toString());
});
$(document).on('click', '#btn_search_false_pos', function () {
    let val = document.querySelector('#input_search_false_pos').value;
    let urlParams = new URLSearchParams(window.location.search);
    urlParams.set('q', val);
    search_for_args(urlParams.toString());
});
$(document).on('click', '#input-search-filter-clear', function (e) {
    document.querySelector('#input_search_false_pos').value = '';
    let ev = jQuery.Event("keyup");
    ev.key = 'Enter';
    $('#input_search_false_pos').trigger(ev);

});
