from django import template

register = template.Library()


@register.filter
def other_zone(value):
    value_list = value.split('|')
    zones = ['body', 'url', 'args', 'headers', 'nomla', 'cookie', 'user-agent', 'content-type', 'x-forward-for',
             'range', 'referer']
    check_value_list = [i for i in value_list if i.lower() not in zones]
    return ','.join(check_value_list)


@register.filter
def check_zone(value, s):
    value_list = value.lower().split('|')
    return s in value_list
