from django.urls import re_path
from .views import add_key, edit_key, remove_key, set_settings, delete_model, model_training, dyn_settings, \
    erl_settings, bl_settings, dyn_rules, settings_info, update_vhost_list, dyn_tab, mlc_tab, \
    rule_management_tab, get_model_duration, set_model_training_duration, \
    erl_rule, get_vhost_list, copy_model, logout_view, func_search_domain, tab_bs_management, bs_management



urlpatterns = [
    re_path(r'dyn/', dyn_tab, name='Dyn tab'),
    re_path(r'mlc/', mlc_tab, name='MLC tab'),
    re_path(r'bs/', tab_bs_management, name='tab_bs_management'),
    re_path(r'bs_managment/', bs_management, name='bs_management'),
    re_path(r'rule_management/', rule_management_tab, name='Rule management tab'),
    re_path(r'get_settings_text/', settings_info, name='Settings info'),
    re_path(r'add_key/', add_key, name='Add key'),
    re_path(r'edit_key/', edit_key, name='Edit key'),
    re_path(r'remove_key/', remove_key, name='Delete key'),
    re_path(r'set_settings/', set_settings, name='Set settings'),
    re_path(r'dyn_settings/', dyn_settings, name='Dyn settings'),
    re_path(r'erl/edit/', erl_settings, name='Edit Erl'),
    re_path(r'erl/add/', erl_settings, name='Add Erl'),
    re_path(r'erl/delete/', erl_settings, name='Delete Erl'),
    re_path(r'bl/add/', bl_settings, name='Add BL'),
    re_path(r'bl/del/', bl_settings, name='Delete BL'),
    re_path(r'bl/get/', bl_settings, name='Get BL'),
    re_path(r'bl/search/', func_search_domain, name='Search BL'),
    re_path(r'add_dyn_rule/', dyn_rules, name='Add WL'),
    re_path(r'edit_dyn_rule/', dyn_rules, name='Edit WL'),
    re_path(r'delete_dyn_rule/', dyn_rules, name='Delete WL'),
    re_path(r'delete_model/', delete_model, name='Delete model'),
    re_path(r'copy_model/', copy_model, name='Copy model'),
    re_path(r'model_training/', model_training, name='Model training'),
    re_path(r'set_model_training_duration/', set_model_training_duration, name='Set model training duration'),
    re_path(r'update_vhost_list/', update_vhost_list, name='Update vhost list'),
    re_path(r'get_vhost_list/', get_vhost_list, name='Get vhost list'),
    re_path(r'erl_rule/', erl_rule, name='ERL rule'),
    re_path(r'get_model_duration/', get_model_duration, name='Get model duration'),
    re_path(r'logout/', logout_view, name='logout'),
]
