from django.urls import re_path
from . import views

urlpatterns = [
    re_path(r'^$', views.summary_nginx, name='summary nginx'),
    re_path(r'main/', views.main_nginx, name='main nginx'),
    re_path(r'tab_main_nginx/', views.tab_main_nginx, name='tab_main_nginx'),
    re_path(r'vhost/', views.vhost_nginx, name='vhost nginx'),
    re_path(r'vhost_tab_content/', views.vhost_nginx_with_tab_content, name='vhost_nginx_with_tab_content'),
    re_path(r'main_vhosts/', views.main_vhosts, name='main_vhosts'),
    re_path(r'main_ssl/', views.main_ssl, name='main_ssl'),
    re_path(r'main_upstream/', views.main_upstream, name='main_upstream'),
    re_path(r'main_location/', views.main_locations, name='main_location'),
    re_path(r'post/set/', views.set_settings_conf, name='set nginx conf'),
    re_path(r'post/del/', views.set_settings_conf, name='del nginx conf'),
    re_path(r'get_settings_info/', views.get_settings_info, name='get settings info'),
    re_path(r'get_data_json/', views.get_data_json, name='get data json'),
]
